# API Reference

This API reference is organized by resource type. Each resource type has one or more data representations and one or more methods.

## Resource types

1. [Users.dataSources](https://developers.google.com/fit/rest/v1/reference#Users.dataSources)
2. [Users.dataSources.dataPointChanges](https://developers.google.com/fit/rest/v1/reference#Users.dataSources.dataPointChanges)
3. [Users.dataSources.datasets](https://developers.google.com/fit/rest/v1/reference#Users.dataSources.datasets)
4. [Users.dataset](https://developers.google.com/fit/rest/v1/reference#Users.dataset)
5. [Users.sessions](https://developers.google.com/fit/rest/v1/reference#Users.sessions)

## Users.dataSources

For Users.dataSources Resource details, see the [resource representation](https://developers.google.com/fit/rest/v1/reference/users/dataSources#resource) page.

| Method | HTTP request | Description |
|---|---|---|
| URIs relative to https://www.googleapis.com/fitness/v1/users, unless otherwise noted |||
| [create](https://developers.google.com/fit/rest/v1/reference/users/dataSources/create) | `POST /userId/dataSources` | Creates a new data source that is unique across all data sources belonging to this user. <br /> A data source is a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point in every dataset inserted into or read from the Fitness API has an associated data source. <br /> Each data source produces a unique stream of dataset updates, with a unique data source identifier. Not all changes to data source affect the data stream ID, so that data collected by updated versions of the same application/device can still be considered to belong to the same data source. <br /> Data sources are identified using a string generated by the server, based on the contents of the source being created. The `dataStreamId` field should not be set when invoking this method. It will be automatically generated by the server with the correct format. If a `dataStreamId` is set, it must match the format that the server would generate. This format is a combination of some fields from the data source, and has a specific order. If it doesn't match, the request will fail with an error. <br /> Specifying a DataType which is not a known type (beginning with "com.google.") will create a DataSource with a *custom data type* . Custom data types are only readable by the application that created them. Custom data types are **deprecated** ; use standard data types instead. <br /> In addition to the data source fields included in the data source ID, the developer project number that is authenticated when creating the data source is included. This developer project number is obfuscated when read by any other developer reading public data types. |
| [delete](https://developers.google.com/fit/rest/v1/reference/users/dataSources/delete) | `DELETE /userId/dataSources/dataSourceId` | Deletes the specified data source. The request will fail if the data source contains any data points. |
| [get](https://developers.google.com/fit/rest/v1/reference/users/dataSources/get) | `GET /userId/dataSources/dataSourceId` | Returns the specified data source. |
| [list](https://developers.google.com/fit/rest/v1/reference/users/dataSources/list) | `GET /userId/dataSources` | Lists all data sources that are visible to the developer, using the OAuth scopes provided. The list is not exhaustive; the user may have private data sources that are only visible to other developers, or calls using other scopes. |
| [update](https://developers.google.com/fit/rest/v1/reference/users/dataSources/update) | `PUT /userId/dataSources/dataSourceId` | Updates the specified data source. The `dataStreamId`, `dataType`, `type`, `dataStreamName`, and `device` properties with the exception of `version`, cannot be modified. <br /> Data sources are identified by their `dataStreamId`. |

## Users.dataSources.dataPointChanges

For Users.dataSources.dataPointChanges Resource details, see the [resource representation](https://developers.google.com/fit/rest/v1/reference/users/dataSources/dataPointChanges#resource) page.

| Method | HTTP request | Description |
|---|---|---|
| URIs relative to https://www.googleapis.com/fitness/v1/users, unless otherwise noted |||
| [list](https://developers.google.com/fit/rest/v1/reference/users/dataSources/dataPointChanges/list) | `GET /userId/dataSources/dataSourceId/dataPointChanges` | Queries for user's data point changes for a particular data source. |

## Users.dataSources.datasets

For Users.dataSources.datasets Resource details, see the [resource representation](https://developers.google.com/fit/rest/v1/reference/users/dataSources/datasets#resource) page.

| Method | HTTP request | Description |
|---|---|---|
| URIs relative to https://www.googleapis.com/fitness/v1/users, unless otherwise noted |||
| [delete](https://developers.google.com/fit/rest/v1/reference/users/dataSources/datasets/delete) | `DELETE /userId/dataSources/dataSourceId/datasets/datasetId` | Performs an inclusive delete of all data points whose start and end times have any overlap with the time range specified by the dataset ID. For most data types, the entire data point will be deleted. For data types where the time span represents a consistent value (such as `com.google.activity.segment`), and a data point straddles either end point of the dataset, only the overlapping portion of the data point will be deleted. |
| [get](https://developers.google.com/fit/rest/v1/reference/users/dataSources/datasets/get) | `GET /userId/dataSources/dataSourceId/datasets/datasetId` | Returns a dataset containing all data points whose start and end times overlap with the specified range of the dataset minimum start time and maximum end time. Specifically, any data point whose start time is less than or equal to the dataset end time and whose end time is greater than or equal to the dataset start time. |
| [patch](https://developers.google.com/fit/rest/v1/reference/users/dataSources/datasets/patch) | `PATCH /userId/dataSources/dataSourceId/datasets/datasetId` | Adds data points to a dataset. The dataset need not be previously created. All points within the given dataset will be returned with subsquent calls to retrieve this dataset. Data points can belong to more than one dataset. <br /> This method does not use patch semantics: the data points provided are merely inserted, with no existing data replaced. |

## Users.dataset

For Users.dataset Resource details, see the [resource representation](https://developers.google.com/fit/rest/v1/reference/users/dataset#resource) page.

| Method | HTTP request | Description |
|---|---|---|
| URIs relative to https://www.googleapis.com/fitness/v1/users, unless otherwise noted |||
| [aggregate](https://developers.google.com/fit/rest/v1/reference/users/dataset/aggregate) | `POST /userId/dataset:aggregate` | Aggregates data of a certain type or stream into buckets divided by a given type of boundary. Multiple data sets of multiple types and from multiple sources can be aggregated into exactly one bucket type per request. |

## Users.sessions

For Users.sessions Resource details, see the [resource representation](https://developers.google.com/fit/rest/v1/reference/users/sessions#resource) page.

| Method | HTTP request | Description |
|---|---|---|
| URIs relative to https://www.googleapis.com/fitness/v1/users, unless otherwise noted |||
| [delete](https://developers.google.com/fit/rest/v1/reference/users/sessions/delete) | `DELETE /userId/sessions/sessionId` | Deletes a session specified by the given session ID. |
| [list](https://developers.google.com/fit/rest/v1/reference/users/sessions/list) | `GET /userId/sessions` | Lists sessions previously created. |
| [update](https://developers.google.com/fit/rest/v1/reference/users/sessions/update) | `PUT /userId/sessions/sessionId` | Updates or insert a given session. |